on CheckPenguin
  global gCurrentTile, gCurrentSequence, gNextTile, gTileList, gNotWaiting, gBeenFed, gGameState, gDifficultyLevel, gGameSol
  case gNextTile of
    (-1):
      gCurrentSequence = "wav"
      sprite(70).member = "wave_l.01"
      exit
    0:
      gCurrentSequence = "wav"
      gTileList = field("Path" & string(gGameState))
      gCurrentTile = 0
      gNextTile = value(item 1 of gTileList)
    5:
      repeat with i = 20 to 49
        puppetSprite(i, 1)
      end repeat
      if marker(0) = label("play") then
        gCurrentSequence = "wkr"
        go("dropRock")
      else
        go(the frame + 1)
        gCurrentSequence = "tur"
      end if
      exit
    100:
      AtBottom = 1
      if sprite(70).locV < 320 then
        AtBottom = 0
      end if
      if AtBottom then
        if gCurrentSequence = "dod" then
          go("replace umbrella")
        else
          sprite(70).locV = 338
          if the locH of sprite 70 > 200 then
            gCurrentSequence = "wkl"
          else
            gTileList = field("Path" & string(gGameState))
            gCurrentTile = 0
            gNextTile = value(item 1 of gTileList)
            gCurrentSequence = "trn"
            if sprite(70).member.name contains "walk" then
              sprite(70).member = "turnback_l.01"
            else
              sprite(70).member = "frontturn_l.01"
            end if
          end if
        end if
      else
        whichSeq = root(sprite(70).member.name)
        gCurrentSequence = "umb"
        case whichSeq of
          "feed_l":
            sprite(70).member = "getUmb1_l.01"
          "getUmb1_l":
            sprite(70).member = "getUmb2_l.01"
          otherwise:
            sprite(70).member = "float_l.01"
            gCurrentSequence = "dod"
        end case
        exit
      end if
    otherwise:
      if not gBeenFed then
        gCurrentTile = gNextTile
        gNextTile = value(item 1 of gTileList)
      end if
      TiletoSprite = "49,48,47,46,45,44,43,42,41,40,39,38,37,36,35,34,33,32,31,30,29,28,27,26,25,24,23,22,21,20"
      thisTileType = sprite(50 - gCurrentTile).member.name
      nextTiletype = sprite(50 - gNextTile).member.name
      myDirection = gNextTile - gCurrentTile
      theSequence = "   "
      case myDirection of
        (-1):
          put "l" into char 3 of theSequence
        1:
          put "r" into char 3 of theSequence
        (-6):
          put "u" into char 3 of theSequence
        6:
          put "d" into char 3 of theSequence
        (-5):
          put "r" into char 3 of theSequence
        (-7):
          put "l" into char 3 of theSequence
      end case
      repeat with i = 1 to 8
        if root(thisTileType) = item i of field "TileTypes" then
          repeat with j = 1 to 8
            if root(nextTiletype) = item j of field "TileTypes" then
              put item j of line i of field "WalkTable" into char 1 to 2 of theSequence
              exit repeat
            end if
          end repeat
        end if
      end repeat
      gCurrentSequence = theSequence
  end case
  if not gBeenFed then
    delete item 1 of gTileList
  end if
  case nextTiletype of
    "ledge", "slide.r", "step.l":
      sprite(71).member = root(nextTiletype) & "cover"
      sprite(71).locH = sprite(50 - gNextTile).locH
      sprite(71).locV = sprite(50 - gNextTile).locV
  end case
  IsObstacleTile = ("ledgegapstep" contains root(nextTiletype)) or ((thisTileType = "flat") and (nextTiletype = "laddcont"))
  case root(nextTiletype) of
    "gap":
      whichFish = "red"
    "ledge":
      whichFish = "dbl"
    "laddcont":
      whichFish = "gre"
    "step":
      whichFish = "yel"
  end case
  needToFeed = not (gGameSol contains whichFish)
  if IsObstacleTile and needToFeed then
    if not gBeenFed then
      gCurrentSequence = "fee"
      gNotWaiting = 0
      if not soundBusy(2) and (marker(0) = label("play")) then
        case whichFish of
          "red":
            HostSound("754248")
          "dbl":
            HostSound("754246")
          "gre":
            HostSound("754242")
          "yel":
            HostSound("754244")
        end case
      end if
    else
      gBeenFed = 0
    end if
  else
    gNotWaiting = 1
    gBeenFed = 0
  end if
  case gCurrentSequence of
    "wkl":
      sprite(70).member = "walk_l.01"
    "wkr":
      sprite(70).member = "walk_r.01"
    "juu":
      sprite(70).member = "jump.01"
    "lel":
      sprite(70).member = "leap_l.01"
    "ler":
      sprite(70).member = "leap_r.01"
    "lal":
      sprite(70).member = "land_l.01"
    "lar":
      sprite(70).member = "land_r.01"
    "sdl":
      sprite(70).member = "slide_l.01"
    "sdr":
      sprite(70).member = "slide_r.01"
    "fee":
      sprite(70).member = "feed_l.01"
    "clu":
      sprite(70).member = "climb.01"
    "sll":
      sprite(70).member = "under1_l.01"
    "slr":
      sprite(70).member = "under1_r.01"
    "sol":
      sprite(70).member = "under2_l.01"
    "sor":
      sprite(70).member = "under2_r.01"
    "dod", "did":
      sprite(70).member = "float_l.01"
    "drd":
      currentSeq = root(sprite(70).member.name)
      if char length(currentSeq) of currentSeq = "l" then
        sprite(70).member = "land_l.01"
      else
        sprite(70).member = "land_r.01"
      end if
    "jxl":
      sprite(70).member = "step1_l.01"
    "jxr":
      sprite(70).member = "step1_r.01"
    "jyl":
      sprite(70).member = "step2_l.01"
    "jyr":
      sprite(70).member = "step2_r.01"
  end case
  if not ((gCurrentTile = 0) or (gNextTile = 100)) and not ("lal,lar,jyl,jyr,sdl,sdr,drd,dod" contains gCurrentSequence) then
    sprite(70).locH = sprite(50 - gCurrentTile).locH
    sprite(70).locV = sprite(50 - gCurrentTile).locV - 4
  end if
  case char 1 to 2 of gCurrentSequence of
    "le":
      puppetSound("leap")
    "sl", "sd":
      puppetSound(4, "slide")
    "ju", "jx", "jy":
      puppetSound("grunt")
    "fe":
      puppetSound("Feed")
    "cl":
      puppetSound("Climb")
    "wk":
      puppetSound(4, "walk")
  end case
end
